# Method: projects.keys.addIpOverride

- [HTTP request](https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/projects.keys/addIpOverride#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/projects.keys/addIpOverride#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/projects.keys/addIpOverride#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/projects.keys/addIpOverride#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/projects.keys/addIpOverride#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/projects.keys/addIpOverride#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/projects.keys/addIpOverride#body.aspect_1)

Adds an IP override to a key. The following restrictions hold: \* The maximum number of IP overrides per key is 1000. \* For any conflict (such as IP already exists or IP part of an existing IP range), an error is returned.

### HTTP request

`POST https://recaptchaenterprise.googleapis.com/v1/{name=projects/*/keys/*}:addIpOverride`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The name of the key to which the IP override is added, in the format `projects/{project}/keys/{key}`. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "ipOverrideData": { object (`https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/IpOverrideData`) } } ``` |

| Fields ||
|---|---|
| `ipOverrideData` | ``object (`https://docs.cloud.google.com/recaptcha/docs/reference/rest/v1/IpOverrideData`)`` Required. IP override added to the key. |

### Response body

If successful, the response body is empty.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `name` resource:

- `recaptchaenterprise.keys.update`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).